## serf 1.3.3

=== SConstruct ===
# -*- python -*-
#
# Copyright 2011-2012 Justin Erenkrantz and Greg Stein
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

import sys
import os
import re

EnsureSConsVersion(2,3,0)

HEADER_FILES = ['serf.h',
                'serf_bucket_types.h',
                'serf_bucket_util.h',
                ]

# where we save the configuration variables
SAVED_CONFIG = '.saved_config'

# Variable class that does no validation on the input
def _converter(val):
    """
    """
    if val == 'none':
      val = []
    else:
      val = val.split(' ')
    return val

def RawListVariable(key, help, default):
    """
    The input parameters describe a 'raw string list' option. This class
    accepts a space-separated string and converts it to a list.
    """
    return (key, '%s' % (help), default, None, lambda val: _converter(val))

# Custom path validator, creates directory when a specified option is set.
# To be used to ensure a PREFIX directory is only created when installing.
def createPathIsDirCreateWithTarget(target):
  def my_validator(key, val, env):
    build_targets = (map(str, BUILD_TARGETS))
    if target in build_targets:
      return PathVariable.PathIsDirCreate(key, val, env)
    else:
      return PathVariable.PathAccept(key, val, env)
  return my_validator

# default directories
if sys.platform == 'win32':
  default_incdir='..'
  default_libdir='..'
  default_prefix='Debug'
else:
  default_incdir='/usr'
  default_libdir='$PREFIX/lib'
  default_prefix='/usr/local'

opts = Variables(files=[SAVED_CONFIG])
opts.AddVariables(
  PathVariable('PREFIX',
               'Directory to install under',
               default_prefix,
               createPathIsDirCreateWithTarget('install')),
  PathVariable('LIBDIR',
               'Directory to install architecture dependent libraries under',
               default_libdir,
               createPathIsDirCreateWithTarget('install')),
  PathVariable('APR',
               "Path to apr-1-config, or to APR's install area",
               default_incdir,
               PathVariable.PathAccept),
  PathVariable('APU',
               "Path to apu-1-config, or to APR's install area",
               default_incdir,
               PathVariable.PathAccept),
  PathVariable('OPENSSL',
               "Path to OpenSSL's install area",
               default_incdir,
               PathVariable.PathIsDir),
  PathVariable('ZLIB',
               "Path to zlib's install area",
               default_incdir,
               PathVariable.PathIsDir),
  PathVariable('GSSAPI',
               "Path to GSSAPI's install area",
               None,
               None),
  BoolVariable('DEBUG',
               "Enable debugging info and strict compile warnings",
               False),
  BoolVariable('APR_STATIC',
               "Enable using a static compiled APR",
               False),
  RawListVariable('CC', "Command name or path of the C compiler", None),
  RawListVariable('CFLAGS', "Extra flags for the C compiler (space-separated)",
                  None),
  RawListVariable('LIBS', "Extra libraries passed to the linker, "
                  "e.g. \"-l<library1> -l<library2>\" (space separated)", None),
  RawListVariable('LINKFLAGS', "Extra flags for the linker (space-separated)",
                  None),
  RawListVariable('CPPFLAGS', "Extra flags for the C preprocessor "
                  "(space separated)", None), 
  )

if sys.platform == 'win32':
  opts.AddVariables(
    # By default SCons builds for the host platform on Windows, when using
    # a supported compiler (E.g. VS2010/VS2012). Allow overriding

    # Note that Scons 1.3 only supports this on Windows and only when
    # constructing Environment(). Later changes to TARGET_ARCH are ignored
    EnumVariable('TARGET_ARCH',
                 "Platform to build for (x86|x64|win32|x86_64)",
                 'x86',
                 allowed_values=('x86', 'x86_64', 'ia64'),
                 map={'X86'  : 'x86',
                      'win32': 'x86',
                      'Win32': 'x86',
                      'x64'  : 'x86_64',
                      'X64'  : 'x86_64'
                     }),

    EnumVariable('MSVC_VERSION',
                 "Visual C++ to use for building (E.g. 11.0, 9.0)",
                 None,
                 allowed_values=('12.0', '11.0', '10.0', '9.0', '8.0', '6.0')
                ),

    # We always documented that we handle an install layout, but in fact we
    # hardcoded source layouts. Allow disabling this behavior.
    # ### Fix default?
    BoolVariable('SOURCE_LAYOUT',
                 "Assume a source layout instead of install layout",
                 True),
    )

env = Environment(variables=opts,
                  tools=('default', 'textfile',),
                  CPPPATH=['.', ],
                  )

env.Append(BUILDERS = {
    'GenDef' : 
      Builder(action = sys.executable + ' build/gen_def.py $SOURCES > $TARGET',
              suffix='.def', src_suffix='.h')
  })

match = re.search('SERF_MAJOR_VERSION ([0-9]+).*'
                  'SERF_MINOR_VERSION ([0-9]+).*'
                  'SERF_PATCH_VERSION ([0-9]+)',
                  env.File('serf.h').get_contents(),
                  re.DOTALL)
MAJOR, MINOR, PATCH = [int(x) for x in match.groups()]
env.Append(MAJOR=str(MAJOR))
env.Append(MINOR=str(MINOR))
env.Append(PATCH=str(PATCH))

# Calling external programs is okay if we're not cleaning or printing help.
# (cleaning: no sense in fetching information; help: we may not know where
# they are)
CALLOUT_OKAY = not (env.GetOption('clean') or env.GetOption('help'))


# HANDLING OF OPTION VARIABLES

unknown = opts.UnknownVariables()
if unknown:
  print 'Unknown variables:', ', '.join(unknown.keys())
  Exit(1)

apr = str(env['APR'])
apu = str(env['APU'])
zlib = str(env['ZLIB'])
gssapi = env.get('GSSAPI', None)

if gssapi and os.path.isdir(gssapi):
  krb5_config = os.path.join(gssapi, 'bin', 'krb5-config')
  if os.path.isfile(krb5_config):
    gssapi = krb5_config
    env['GSSAPI'] = krb5_config

debug = env.get('DEBUG', None)
aprstatic = env.get('APR_STATIC', None)

Help(opts.GenerateHelpText(env))
opts.Save(SAVED_CONFIG, env)


# PLATFORM-SPECIFIC BUILD TWEAKS

thisdir = os.getcwd()
libdir = '$LIBDIR'
incdir = '$PREFIX/include/serf-$MAJOR'

# This version string is used in the dynamic library name, and for Mac OS X also
# for the current_version and compatibility_version options in the .dylib
#
# Unfortunately we can't set the .dylib compatibility_version option separately
# from current_version, so don't use the PATCH level to avoid that build and
# runtime patch levels have to be identical.
env['SHLIBVERSION'] = '%d.%d.%d' % (MAJOR, MINOR, 0)

LIBNAME = 'libserf-%d' % (MAJOR,)
if sys.platform != 'win32':
  LIBNAMESTATIC = LIBNAME
else:
  LIBNAMESTATIC = 'serf-${MAJOR}'

env.Append(RPATH=libdir,
           PDB='${TARGET.filebase}.pdb')

if sys.platform == 'darwin':
#  linkflags.append('-Wl,-install_name,@executable_path/%s.dylib' % (LIBNAME,))
  env.Append(LINKFLAGS='-Wl,-install_name,%s/%s.dylib' % (thisdir, LIBNAME,))

if sys.platform != 'win32':
  ### gcc only. figure out appropriate test / better way to check these
  ### flags, and check for gcc.
  env.Append(CFLAGS='-std=c89')

  ### These warnings are not available on Solaris
  if sys.platform != 'sunos5': 
    env.Append(CCFLAGS=['-Wdeclaration-after-statement',
                        '-Wmissing-prototypes',
                        '-Wall'])

  if debug:
    env.Append(CCFLAGS='-g')
    env.Append(CPPDEFINES=['DEBUG', '_DEBUG'])
  else:
    env.Append(CCFLAGS='-O2')
    env.Append(CPPDEFINES='NDEBUG')

  ### works for Mac OS. probably needs to change
  env.Append(LIBS=['ssl', 'crypto', 'z', ])

  if sys.platform == 'sunos5':
    env.Append(LIBS='m')
else:
  # Warning level 4, no unused argument warnings
  env.Append(CCFLAGS=['/W4', '/wd4100'])

  # Choose runtime and optimization
  if debug:
    # Disable optimizations for debugging, use debug DLL runtime
    env.Append(CCFLAGS=['/Od', '/MDd'])
    env.Append(CPPDEFINES=['DEBUG', '_DEBUG'])
  else:
    # Optimize for speed, use DLL runtime
    env.Append(CCFLAGS=['/O2', '/MD'])
    env.Append(CPPDEFINES='NDEBUG')
    env.Append(LINKFLAGS='/RELEASE')

# PLAN THE BUILD
SHARED_SOURCES = []
if sys.platform == 'win32':
  env.GenDef(['serf.h','serf_bucket_types.h', 'serf_bucket_util.h'])
  SHARED_SOURCES.append(['serf.def'])

SOURCES = Glob('*.c') + Glob('buckets/*.c') + Glob('auth/*.c')

lib_static = env.StaticLibrary(LIBNAMESTATIC, SOURCES)
lib_shared = env.SharedLibrary(LIBNAME, SOURCES + SHARED_SOURCES)

if aprstatic:
  env.Append(CPPDEFINES=['APR_DECLARE_STATIC', 'APU_DECLARE_STATIC'])

if sys.platform == 'win32':
  env.Append(LIBS=['user32.lib', 'advapi32.lib', 'gdi32.lib', 'ws2_32.lib',
                   'crypt32.lib', 'mswsock.lib', 'rpcrt4.lib', 'secur32.lib'])

  # Get apr/apu information into our build
  env.Append(CPPDEFINES=['WIN32','WIN32_LEAN_AND_MEAN','NOUSER',
                         'NOGDI', 'NONLS','NOCRYPT'])

  if env.get('TARGET_ARCH', None) == 'x86_64':
    env.Append(CPPDEFINES=['WIN64'])

  if aprstatic:
    apr_libs='apr-1.lib'
    apu_libs='aprutil-1.lib'
  else:
    apr_libs='libapr-1.lib'
    apu_libs='libaprutil-1.lib'

  env.Append(LIBS=[apr_libs, apu_libs])
  if not env.get('SOURCE_LAYOUT', None):
    env.Append(LIBPATH=['$APR/lib', '$APU/lib'],
               CPPPATH=['$APR/include/apr-1', '$APU/include/apr-1'])
  elif aprstatic:
    env.Append(LIBPATH=['$APR/LibR','$APU/LibR'],
               CPPPATH=['$APR/include', '$APU/include'])
  else:
    env.Append(LIBPATH=['$APR/Release','$APU/Release'],
               CPPPATH=['$APR/include', '$APU/include'])

  # zlib
  env.Append(LIBS='zlib.lib')
  if not env.get('SOURCE_LAYOUT', None):
    env.Append(CPPPATH='$ZLIB/include',
               LIBPATH='$ZLIB/lib')
  else:
    env.Append(CPPPATH='$ZLIB',
               LIBPATH='$ZLIB')

  # openssl
  env.Append(LIBS=['libeay32.lib', 'ssleay32.lib'])
  if not env.get('SOURCE_LAYOUT', None):
    env.Append(CPPPATH='$OPENSSL/include/openssl',
               LIBPATH='$OPENSSL/lib')
  elif 0: # opensslstatic:
    env.Append(CPPPATH='$OPENSSL/inc32',
               LIBPATH='$OPENSSL/out32')
  else:
    env.Append(CPPPATH='$OPENSSL/inc32',
               LIBPATH='$OPENSSL/out32dll')
else:
  if os.path.isdir(apr):
    apr = os.path.join(apr, 'bin', 'apr-1-config')
    env['APR'] = apr
  if os.path.isdir(apu):
    apu = os.path.join(apu, 'bin', 'apu-1-config')
    env['APU'] = apu

  ### we should use --cc, but that is giving some scons error about an implict
  ### dependency upon gcc. probably ParseConfig doesn't know what to do with
  ### the apr-1-config output
  if CALLOUT_OKAY:
    env.ParseConfig('$APR --cflags --cppflags --ldflags --includes'
                    ' --link-ld --libs')
    env.ParseConfig('$APU --ldflags --includes --link-ld --libs')

  ### there is probably a better way to run/capture output.
  ### env.ParseConfig() may be handy for getting this stuff into the build
  if CALLOUT_OKAY:
    apr_libs = os.popen(env.subst('$APR --link-libtool --libs')).read().strip()
    apu_libs = os.popen(env.subst('$APU --link-libtool --libs')).read().strip()
  else:
    apr_libs = ''
    apu_libs = ''

  env.Append(CPPPATH='$OPENSSL/include')
  env.Append(LIBPATH='$OPENSSL/lib')


# If build with gssapi, get its information and define SERF_HAVE_GSSAPI
if gssapi and CALLOUT_OKAY:
    env.ParseConfig('$GSSAPI --cflags gssapi')

=== debian/changelog ===
serf (1.3.3-1ubuntu0.1) trusty-security; urgency=medium

  * SECURITY UPDATE: cert spoofing via NUL characters in CommonName and
    SubjectAltNames
    - debian/patches/CVE-2014-3504.patch: escape null bytes in
      buckets/ssl_buckets.c.
    - CVE-2014-3504
  * Fix FTBFS because of expired test certs:
    - debian/patches/expired_certs.patch: switch to test certs from serf
      1.3.6.
    - debian/source/format: switch to 3.0 (quilt) so we can handle the
      binary cert file
    - debian/source/include-binaries: include binary cert file from 1.3.6.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 14 Aug 2014 09:47:32 -0400

serf (1.3.3-1) unstable; urgency=low

  * Add myself to Uploaders.
  * Change the watch file to better handle code.google.com.
  * New upstream release.  (Closes: #716793)
    + Refresh patches/libtool
    + Update symbols
  * Adapt packaging for the upstream switch to SCons.
    + control: + scons, - autotools-dev, autoconf
    + rules: Change configure/make calls to scons
  * Rename libserf1 to libserf-1-1, following standard naming conventions.
  * Enable hardening flags.
  * Strip unnecessary RPATH from libserf.
  * Honor DEB_BUILD_OPTIONS=parallel=X

 -- James McCoy <jamessan@debian.org>  Tue, 31 Dec 2013 13:17:16 -0500

serf (1.1.0-2) unstable; urgency=low

  * Upload to unstable.
  * Add another lintian override.
  * Make libserf1-dbg M-A: same as well.

 -- Peter Samuelson <peter@p12n.org>  Sat, 09 Jun 2012 14:26:56 -0500

serf (1.1.0-1) experimental; urgency=low

  * New upstream version.
  * Policy 3.9.3 (no changes).

 -- Peter Samuelson <peter@p12n.org>  Fri, 08 Jun 2012 00:18:56 -0500

serf (1.0.1-1) experimental; urgency=low

  * New upstream release.
    - patches/bind_address_family: Delete, applied upstream.
  * Delete obsolete lintian override (workaround for an old lintian).

 -- Peter Samuelson <peter@p12n.org>  Sat, 25 Feb 2012 14:43:53 -0600

serf (1.0.0-2) experimental; urgency=low

  * patches/bind_address_family: New patch from Anders Kaseorg to replace
    patches/ip6-localhost.  We'll see if it addresses #632573.
  * Policy 3.9.2 (no changes).

 -- Peter Samuelson <peter@p12n.org>  Wed, 17 Aug 2011 17:12:21 -0500

serf (1.0.0-1) experimental; urgency=low

  * New upstream release.
    - patches/out-of-tree, patches/kqueue: Remove, accepted upstream.
    - Now ships pkgconfig file serf-1.pc.

 -- Peter Samuelson <peter@p12n.org>  Fri, 15 Jul 2011 17:49:29 -0500

serf (1.0.0~0+svn1514-1) experimental; urgency=low

  * New upstream snapshot.
    - patches/abi-0.x: Remove as obsolete.
    - patches/kqueue: Forward-port.
    - Bump ABI: libserf0.7{,-dbg} -> libserf1{,-dbg}
    - patches/ip6-localhost: New patch: temporary (I hope) workaround for
      IPv4 / IPv6 confusion in testsuite.
  * Implement Multi-Arch: same.
  * libserf-dev Conflicts: libserf-0-0-dev, not Breaks.  Thanks, lintian.

 -- Peter Samuelson <peter@p12n.org>  Mon, 27 Jun 2011 18:09:28 -0500

serf (0.7.2-1) experimental; urgency=low

  * New upstream release.
    - patches/no-export-vars: delete, now upstream.
  * New ABI:
    - patches/abi-0.x: New patch to change upstream SONAME.
    - Rename libserf-0-0 to libserf0.7.
    - Rename libserf-0-0-dev to libserf-dev while we're at it.
  * Policy 3.9.1: one instance of s/Conflicts/Breaks/.
  * "Upgrade" to source format 1.0.
  * Add some Depends: ${misc:Depends}; thanks, Lintian.

 -- Peter Samuelson <peter@p12n.org>  Fri, 03 Jun 2011 03:18:07 -0500

serf (0.3.1-1) unstable; urgency=low

  * New upstream release.
    - patches/libtool: update.

 -- Peter Samuelson <peter@p12n.org>  Sun, 14 Feb 2010 23:04:17 -0600

serf (0.3.0-2) unstable; urgency=low

  * Make libserf-0-0-dev Replace older libserf-0-0.  (Closes: #557889)

 -- Peter Samuelson <peter@p12n.org>  Tue, 24 Nov 2009 21:55:31 -0600

serf (0.3.0-1) unstable; urgency=low

  * New maintainer.  (Closes: #554068)  Ack my NMUs.
  * Repackage, without cdbs.
  * Install headers to /usr/include/serf-0 (upstream default), not /usr/include.
  * Do not ship .la file; pretty sure nobody needs it anymore.
  * patches/out-of-tree: New patch, for building outside the source tree.
  * Fix Section of libserf-0-0-dbg to 'debug'.  Thanks, Lintian.

 -- Peter Samuelson <peter@p12n.org>  Mon, 23 Nov 2009 03:25:24 -0600

serf (0.3.0-0.3) unstable; urgency=low

  * Non-maintainer upload.
  * patches/kqueue: New patch: fix FTBFS due to testsuite bug on BSD kernels.
    Thanks Aurelien Jarno.  (Closes: #542063)

 -- Peter Samuelson <peter@p12n.org>  Thu, 20 Aug 2009 08:36:44 -0500

serf (0.3.0-0.2) unstable; urgency=low

  * Non-maintainer upload.
  * Add symbols file.
  * patches/no-export-vars: New patch: do not export variables outside the
    serf_ namespace.

 -- Peter Samuelson <peter@p12n.org>  Sat, 04 Jul 2009 12:16:46 -0500

serf (0.3.0-0.1) unstable; urgency=low

  * Non-maintainer upload.
  * New upstream version.  (Closes: #520546)
    - Deleted patches/work-around-an-error-of-libtool.diff, no longer needed.

 -- Peter Samuelson <peter@p12n.org>  Tue, 23 Jun 2009 18:03:44 -0500

serf (0.2.0-1) unstable; urgency=medium

  * New upstream version (Closes: #485025):
    - debian/copyright: Document that CuTest files are licensed under the
      zlib/libpng license.
    - debian/patches/*.diff: Refresh.
  * Update Standards-Version to 3.8.0.
    - debian/control: Make binNMU-safe by using ${binary:Version} instead of
      ${Source-Version}.
    - debian/control: Add new Homepage field.
    - debian/copyright: Delete copy of /usr/share/common-licenses/Apache-2.0.
    - debian/README.source: New file explaining quilt.
  * Update the debhelper compatibility level to 7.
    - debian/libserf-0-0-dev.install, debian/libserf-0-0.install:
      Do not begin with debian/tmp since it is assumed to be the source path.
  * debian/control: Add new Vcs-Git, and Vcs-Browser fields.
  * Install test programs as example ones for libserf-0-0-dev.



=== debian/control ===
Source: serf
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Peter Samuelson <peter@p12n.org>
Uploaders: James McCoy <jamessan@debian.org>
Build-Depends: dpkg-dev (>= 1.16.0~), debhelper, scons (>= 2.3.0),
    quilt, libapr1-dev, libaprutil1-dev, chrpath
Standards-Version: 3.9.3
Homepage: http://code.google.com/p/serf/

Package: libserf-1-1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: multiarch-support
Multi-Arch: same
Description: high-performance asynchronous HTTP client library
 serf library is a C-based HTTP client library built upon the Apache
 Portable Runtime (APR) library.  It multiplexes connections, running the
 read/write communication asynchronously.  Memory copies and
 transformations are kept to a minimum to provide high performance
 operation.

Package: libserf-dev
Section: libdevel
Architecture: any
Depends: libserf-1-1 (= ${binary:Version}), ${misc:Depends}, libapr1-dev, libaprutil1-dev
Description: high-performance asynchronous HTTP client library headers
 serf library is a C-based HTTP client library built upon the Apache
 Portable Runtime (APR) library.  It multiplexes connections, running the
 read/write communication asynchronously.  Memory copies and
 transformations are kept to a minimum to provide high performance
 operation.
 .
 This package contains development headers for serf.

Package: libserf1-dbg
Section: debug
Priority: extra
Architecture: any
Multi-Arch: same
Depends: libserf-1-1 (= ${binary:Version}), ${misc:Depends}
Provides: libserf-dbg
Description: high-performance asynchronous HTTP client library debugging symbols
 serf library is a C-based HTTP client library built upon the Apache
 Portable Runtime (APR) library.  It multiplexes connections, running the
 read/write communication asynchronously.  Memory copies and
 transformations are kept to a minimum to provide high performance
 operation.
 .
 This package contains the debugging symbols for serf.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

DEB_LDFLAGS_MAINT_APPEND=-Wl,-z,defs
include /usr/share/dpkg/buildflags.mk
include /usr/share/quilt/quilt.make

DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

libdir := /usr/lib/$(DEB_HOST_MULTIARCH)
includedir := /usr/include
libpkg := libserf-1-1

parallel :=
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    parallel := -j $(NUMJOBS)
endif

build: build-arch build-indep
build-indep:
build-arch: debian/stamp-build
debian/stamp-build: patch
	dh_testdir

	scons $(parallel) PREFIX=/usr LIBDIR=$(libdir) \
		CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" LINKFLAGS="$(LDFLAGS)"
ifeq (, $(filter nocheck,$(DEB_BUILD_OPTIONS)))
	scons check
endif

	touch $@

clean: unpatch
	dh_testdir

	scons -c
	rm -f debian/stamp-* .saved_config .sconsign.dblite config.log

	dh_clean

install: debian/stamp-build
	dh_testdir
	dh_testroot
	dh_clean -k

	scons install --install=$(CURDIR)/debian/tmp
	chrpath -d $(CURDIR)/debian/tmp/$(libdir)/*.so.*

binary-indep: build install

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs -s CHANGES
	dh_installdocs -s NOTICE
	dh_installexamples -s
	dh_installman -s
	install -d debian/$(libpkg)/$(libdir) debian/libserf-dev/$(libdir)
	install -d debian/libserf-dev/$(includedir)
	mv debian/tmp/$(libdir)/*.so.* debian/$(libpkg)/$(libdir)/
	mv debian/tmp/$(libdir)/*.so debian/libserf-dev/$(libdir)/
	mv debian/tmp/$(libdir)/*.a debian/libserf-dev/$(libdir)/
	mv debian/tmp/$(libdir)/pkgconfig debian/libserf-dev/$(libdir)/
	mv debian/tmp/$(includedir)/* debian/libserf-dev/$(includedir)/
	for p in $$(dh_listpackages -s -N$(libpkg)); do \
		doc0=debian/$$p/usr/share/doc/$(libpkg); \
		doc=debian/$$p/usr/share/doc/$$p; \
		rm -f $$doc/changelog* $$doc/copyright; \
		mv $$doc $$doc0; \
		rmdir --ignore-fail-on-non-empty $$doc0; \
		ln -s $(libpkg) $$doc; \
	done;
	dh_link -s
	dh_strip -s --dbg-package=libserf1-dbg
	dh_compress -s
	dh_fixperms -s
	dh_makeshlibs -s
	dh_installdeb -s
	dh_shlibdeps -s
	sed -i 's:libserf-private\(, *\)\?::' debian/*.substvars
	dh_lintian -s || true
	dh_gencontrol -s
	dh_md5sums -s
	dh_builddeb -s

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
# Watch control file for uscan

version=3
http://code.google.com/p/serf/downloads/list?can=1 \
  .*/serf-(.*).tar.bz2

## serf 1.3.9

=== SConstruct ===
--- 
+++ 
@@ -1,18 +1,23 @@
 # -*- python -*-
 #
-# Copyright 2011-2012 Justin Erenkrantz and Greg Stein
-#
-# Licensed under the Apache License, Version 2.0 (the "License");
-# you may not use this file except in compliance with the License.
-# You may obtain a copy of the License at
-#
-#     http://www.apache.org/licenses/LICENSE-2.0
-#
-# Unless required by applicable law or agreed to in writing, software
-# distributed under the License is distributed on an "AS IS" BASIS,
-# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-# See the License for the specific language governing permissions and
-# limitations under the License.
+# ====================================================================
+#    Licensed to the Apache Software Foundation (ASF) under one
+#    or more contributor license agreements.  See the NOTICE file
+#    distributed with this work for additional information
+#    regarding copyright ownership.  The ASF licenses this file
+#    to you under the Apache License, Version 2.0 (the
+#    "License"); you may not use this file except in compliance
+#    with the License.  You may obtain a copy of the License at
+# 
+#      http://www.apache.org/licenses/LICENSE-2.0
+# 
+#    Unless required by applicable law or agreed to in writing,
+#    software distributed under the License is distributed on an
+#    "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+#    KIND, either express or implied.  See the License for the
+#    specific language governing permissions and limitations
+#    under the License.
+# ====================================================================
 #
 
 import sys
@@ -135,7 +140,8 @@
     EnumVariable('MSVC_VERSION',
                  "Visual C++ to use for building (E.g. 11.0, 9.0)",
                  None,
-                 allowed_values=('12.0', '11.0', '10.0', '9.0', '8.0', '6.0')
+                 allowed_values=('14.0', '12.0',
+                                 '11.0', '10.0', '9.0', '8.0', '6.0')
                 ),
 
     # We always documented that we handle an install layout, but in fact we
@@ -177,8 +183,7 @@
 
 unknown = opts.UnknownVariables()
 if unknown:
-  print 'Unknown variables:', ', '.join(unknown.keys())
-  Exit(1)
+  print 'Warning: Used unknown variables:', ', '.join(unknown.keys())
 
 apr = str(env['APR'])
 apu = str(env['APU'])
@@ -210,7 +215,8 @@
 # Unfortunately we can't set the .dylib compatibility_version option separately
 # from current_version, so don't use the PATCH level to avoid that build and
 # runtime patch levels have to be identical.
-env['SHLIBVERSION'] = '%d.%d.%d' % (MAJOR, MINOR, 0)
+if sys.platform != 'sunos5':
+  env['SHLIBVERSION'] = '%d.%d.%d' % (MAJOR, MINOR, 0)
 
 LIBNAME = 'libserf-%d' % (MAJOR,)
 if sys.platform != 'win32':
@@ -223,31 +229,43 @@
 
 if sys.platform == 'darwin':
 #  linkflags.append('-Wl,-install_name,@executable_path/%s.dylib' % (LIBNAME,))
-  env.Append(LINKFLAGS='-Wl,-install_name,%s/%s.dylib' % (thisdir, LIBNAME,))
+  env.Append(LINKFLAGS=['-Wl,-install_name,%s/%s.dylib' % (thisdir, LIBNAME,)])
 
 if sys.platform != 'win32':
-  ### gcc only. figure out appropriate test / better way to check these
-  ### flags, and check for gcc.
-  env.Append(CFLAGS='-std=c89')
-
-  ### These warnings are not available on Solaris
-  if sys.platform != 'sunos5': 
+  def CheckGnuCC(context):
+    src = '''
+    #ifndef __GNUC__
+    oh noes!
+    #endif
+    '''
+    context.Message('Checking for GNU-compatible C compiler...')
+    result = context.TryCompile(src, '.c')
+    context.Result(result)
+    return result
+
+  conf = Configure(env, custom_tests = dict(CheckGnuCC=CheckGnuCC))
+  have_gcc = conf.CheckGnuCC()
+  env = conf.Finish()
+
+  if have_gcc:
+    env.Append(CFLAGS=['-std=c89'])
     env.Append(CCFLAGS=['-Wdeclaration-after-statement',
                         '-Wmissing-prototypes',
                         '-Wall'])
 
   if debug:
-    env.Append(CCFLAGS='-g')
+    env.Append(CCFLAGS=['-g'])
     env.Append(CPPDEFINES=['DEBUG', '_DEBUG'])
   else:
-    env.Append(CCFLAGS='-O2')
-    env.Append(CPPDEFINES='NDEBUG')
+    env.Append(CCFLAGS=['-O2'])
+    env.Append(CPPDEFINES=['NDEBUG'])
 
   ### works for Mac OS. probably needs to change
   env.Append(LIBS=['ssl', 'crypto', 'z', ])
 
   if sys.platform == 'sunos5':
-    env.Append(LIBS='m')
+    env.Append(LIBS=['m'])
+    env.Append(PLATFORM='posix')
 else:
   # Warning level 4, no unused argument warnings
   env.Append(CCFLAGS=['/W4', '/wd4100'])
@@ -260,8 +278,8 @@
   else:
     # Optimize for speed, use DLL runtime
     env.Append(CCFLAGS=['/O2', '/MD'])
-    env.Append(CPPDEFINES='NDEBUG')
-    env.Append(LINKFLAGS='/RELEASE')
+    env.Append(CPPDEFINES=['NDEBUG'])
+    env.Append(LINKFLAGS=['/RELEASE'])
 
 # PLAN THE BUILD
 SHARED_SOURCES = []
@@ -291,6 +309,7 @@
   if aprstatic:
     apr_libs='apr-1.lib'
     apu_libs='aprutil-1.lib'
+    env.Append(LIBS=['shell32.lib', 'xml.lib'])
   else:
     apr_libs='libapr-1.lib'
     apu_libs='libaprutil-1.lib'
@@ -307,25 +326,25 @@
                CPPPATH=['$APR/include', '$APU/include'])
 
   # zlib
-  env.Append(LIBS='zlib.lib')
+  env.Append(LIBS=['zlib.lib'])
   if not env.get('SOURCE_LAYOUT', None):
-    env.Append(CPPPATH='$ZLIB/include',
-               LIBPATH='$ZLIB/lib')
-  else:
-    env.Append(CPPPATH='$ZLIB',
-               LIBPATH='$ZLIB')
+    env.Append(CPPPATH=['$ZLIB/include'],
+               LIBPATH=['$ZLIB/lib'])
+  else:
+    env.Append(CPPPATH=['$ZLIB'],
+               LIBPATH=['$ZLIB'])
 
   # openssl
   env.Append(LIBS=['libeay32.lib', 'ssleay32.lib'])
   if not env.get('SOURCE_LAYOUT', None):
-    env.Append(CPPPATH='$OPENSSL/include/openssl',
-               LIBPATH='$OPENSSL/lib')
+    env.Append(CPPPATH=['$OPENSSL/include/openssl'],
+               LIBPATH=['$OPENSSL/lib'])
   elif 0: # opensslstatic:
-    env.Append(CPPPATH='$OPENSSL/inc32',
-               LIBPATH='$OPENSSL/out32')
-  else:
-    env.Append(CPPPATH='$OPENSSL/inc32',
-               LIBPATH='$OPENSSL/out32dll')
+    env.Append(CPPPATH=['$OPENSSL/inc32'],
+               LIBPATH=['$OPENSSL/out32'])
+  else:
+    env.Append(CPPPATH=['$OPENSSL/inc32'],
+               LIBPATH=['$OPENSSL/out32dll'])
 else:
   if os.path.isdir(apr):
     apr = os.path.join(apr, 'bin', 'apr-1-config')
@@ -338,23 +357,3 @@
   ### dependency upon gcc. probably ParseConfig doesn't know what to do with
   ### the apr-1-config output
   if CALLOUT_OKAY:
-    env.ParseConfig('$APR --cflags --cppflags --ldflags --includes'
-                    ' --link-ld --libs')
-    env.ParseConfig('$APU --ldflags --includes --link-ld --libs')
-
-  ### there is probably a better way to run/capture output.
-  ### env.ParseConfig() may be handy for getting this stuff into the build
-  if CALLOUT_OKAY:
-    apr_libs = os.popen(env.subst('$APR --link-libtool --libs')).read().strip()
-    apu_libs = os.popen(env.subst('$APU --link-libtool --libs')).read().strip()
-  else:
-    apr_libs = ''
-    apu_libs = ''
-
-  env.Append(CPPPATH='$OPENSSL/include')
-  env.Append(LIBPATH='$OPENSSL/lib')
-
-
-# If build with gssapi, get its information and define SERF_HAVE_GSSAPI
-if gssapi and CALLOUT_OKAY:
-    env.ParseConfig('$GSSAPI --cflags gssapi')

=== debian/changelog ===
serf (1.3.9-11) UNRELEASED; urgency=medium

  * update

 -- James McCoy <jamessan@debian.org>  Thu, 16 Jun 2022 14:25:41 +0800

serf (1.3.9-11) unstable; urgency=medium

  [ James McCoy ]
  * Fix build with OpenSSL 3 (Closes: #1006572)
  * Ignore test failures until upstream fixes their tests with OpenSSL 3
  * Declare compliance with Policy 4.6.1, no changes needed

  [ Simon Chopin ]
  * d/p/bio-ctrl.patch: imported from FreeBSD, fixes TLS issues with OpenSSL3
    (LP: #1956040)

  [ Vagrant Cascadian ]
  * debian/rules: Pass relative path to LIBDIR in dh_auto_install override.
    (Closes: #1010043)

 -- James McCoy <jamessan@debian.org>  Sat, 14 May 2022 16:57:22 -0400

serf (1.3.9-10) unstable; urgency=medium

  * ci: Add pkg-config to Depends
  * ci: Add allow-stderr restriction

 -- James McCoy <jamessan@debian.org>  Sun, 17 Jan 2021 09:57:34 -0500

serf (1.3.9-9) unstable; urgency=medium

  * Include upstream patch to fix OpenSSL 1.1.1i compat (Closes: #978353)
  * rules: Remove explicit -Wl,--as-needed, since it is default
  * Run upstream tests for CI

 -- James McCoy <jamessan@debian.org>  Sat, 16 Jan 2021 10:35:52 -0500

serf (1.3.9-8) unstable; urgency=medium

  * Enable building with Python3
    - Use Python3 to generate test certificates
      + Change python-openssl Build-Depends to python3-openssl
    - Add py3-compat patch
      + Use py2/py3 compatible syntax in SConstruct (Closes: #947581)
      + Use py2/py3 compatible syntax in build/*.py (Closes: #943263)
  * Remove debian/distcerts/ in clean target
  * debian/rules:
    - Build tests with the same flags as the library
    - Add support for DEB_BUILD_OPTIONS=terse
    - Remove unnecessary -arch qualifications in override rules
    - Add .PHONY build rule to override build directory
  * debian/control:
    - Remove obsolete version requirement for scons Build-Depends
  * Install libserf-dev examples in /usr/share/doc/libserf-dev instead of
    symlinking to /u/s/d/libserf-1-1
  * Add script to update/minimize signing keys
  * Update/minimize upstream signing keys
  * Declare compliance with Policy 4.4.1, no changes needed
  * Switch to debhelper compat 12 via debhelper-compat

 -- James McCoy <jamessan@debian.org>  Mon, 30 Dec 2019 07:55:43 -0500

serf (1.3.9-7) unstable; urgency=medium

  * Backport create_certs.py from upstream to generate certs at test time
    (Closes: #911714)
  * Remove obsolete dbgsym migration
  * Opt-in to debhelper 12 beta
  * Declare compliance with Policy 4.2.1

 -- James McCoy <jamessan@debian.org>  Sat, 27 Oct 2018 10:17:10 -0400

serf (1.3.9-6) unstable; urgency=medium

  * Backport r1712790 from upstream to fix NULL pointer dereference.
    Thanks to Colin Watson for investigation and report (Closes: #893688)

 -- James McCoy <jamessan@debian.org>  Wed, 21 Mar 2018 21:38:37 -0400

serf (1.3.9-5) unstable; urgency=medium

  * control: Change Vcs-* to salsa.debian.org
  * Bump debhelper compat to 11
  * control: Declare compliance with Policy 4.1.3
  * control: Mark libserf-dev Multi-Arch: same

 -- James McCoy <jamessan@debian.org>  Thu, 15 Mar 2018 21:57:08 -0400

serf (1.3.9-4) unstable; urgency=medium

  * Mark serf_debug__closed_conn as a public symbol, since svn has been using
    it for 10 years.
  * Declare compliance with Policy 4.1.1, no changes needed
  * Change source format to 3.0 (quilt)
  * Set R³ to no
  * Switch to dh-based rules

 -- James McCoy <jamessan@debian.org>  Sun, 12 Nov 2017 21:19:32 -0500

serf (1.3.9-3) unstable; urgency=medium

  * Add libssl-dev to libserf-dev's Depends, otherwise pkg-config can't
    provide information about serf.  Thanks to Daniel Shahaf for noticing!

 -- James McCoy <jamessan@debian.org>  Wed, 07 Jun 2017 23:09:48 -0400

serf (1.3.9-2) unstable; urgency=medium

  * Remove Peter Samuelson as maintainer, at request of MIA team.  Thanks for
    all the fish!  (Closes: #852220)
  * Backport r1792234 to fix test failures due to expired test certificates.
    (Closes: #862027)

 -- James McCoy <jamessan@debian.org>  Sun, 07 May 2017 22:02:00 -0400

serf (1.3.9-1) unstable; urgency=medium

  * New upstream release
    - patches/comment-style_r2443, patches/openssl-1.1.x_r1750819,
      patches/test-memory-usage_r2445: Drop, merged upstream
  * d/rules: Remove more SCons cruft in clean target

 -- James McCoy <jamessan@debian.org>  Fri, 02 Sep 2016 00:20:04 -0400

serf (1.3.8-3) unstable; urgency=medium

  * Backport r1750819 from upstream to add support for OpenSSL 1.1.x.
    (Closes: #828541)
  * Replace deprecated uses of debhelper's -s with -a.
  * Declare compliance with policy 3.9.8, no changes needed.
  * Use https URIs for Vcs-*.
  * Enable hardening build flags.

 -- James McCoy <jamessan@debian.org>  Sat, 23 Jul 2016 23:39:33 -0400

serf (1.3.8-2) unstable; urgency=medium

  * Update URLs to refer to serf.apache.org rather than code.google.com.
  * Declare compliance with policy 3.9.7, no changes needed.
  * Migrate to automatic debug packages.

 -- James McCoy <jamessan@debian.org>  Sun, 28 Feb 2016 07:37:33 -0500

serf (1.3.8-1) unstable; urgency=medium

  * New upstream release
    - Disable SSLv2 and SSLv3
  * Backport r2445 from upstream to fix potential memory allocation failures
    in the test suite.
  * Backport r2443 from upstream to fix a compile failure in the test suite.

 -- James McCoy <jamessan@debian.org>  Thu, 04 Dec 2014 19:06:24 -0500

serf (1.3.7-3) unstable; urgency=medium

  * Specify the proper prefix/libdir when building libserf-1.pc.
    (Closes: LP: #1388271)

 -- James McCoy <jamessan@debian.org>  Mon, 17 Nov 2014 21:12:38 -0500

serf (1.3.7-2) unstable; urgency=medium

  * debian/control:
    + Bump versioned Build-Depends on scons >= 2.3.1-2 to ensure we have an
      scons which can understand krb5-config's use of -isystem (c.f., #760804).
    + Add libssl-dev/zlib1g-dev to Build-Depends as they're needed to build
      and no longer transitively pulled in.  (Closes: #768664)



=== debian/control ===
Source: serf
Section: libs
Priority: optional
Maintainer: James McCoy <jamessan@debian.org>
Build-Depends:
 chrpath,
 debhelper-compat (= 12),
 libapr1-dev,
 libaprutil1-dev,
 libkrb5-dev,
 libssl-dev,
 python3-openssl <!nocheck>,
 scons,
 zlib1g-dev,
Standards-Version: 4.6.1
Homepage: https://serf.apache.org/
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/jamessan/serf.git
Vcs-Browser: https://salsa.debian.org/jamessan/serf

Package: libserf-1-1
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Multi-Arch: same
Description: high-performance asynchronous HTTP client library
 serf library is a C-based HTTP client library built upon the Apache
 Portable Runtime (APR) library.  It multiplexes connections, running the
 read/write communication asynchronously.  Memory copies and
 transformations are kept to a minimum to provide high performance
 operation.

Package: libserf-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libapr1-dev,
 libaprutil1-dev,
 libserf-1-1 (= ${binary:Version}),
 libssl-dev,
 ${misc:Depends},
Description: high-performance asynchronous HTTP client library headers
 serf library is a C-based HTTP client library built upon the Apache
 Portable Runtime (APR) library.  It multiplexes connections, running the
 read/write communication asynchronously.  Memory copies and
 transformations are kept to a minimum to provide high performance
 operation.
 .
 This package contains development headers for serf.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DEB_BUILD_MAINT_OPTIONS=hardening=+all
DEB_LDFLAGS_MAINT_APPEND=-Wl,-z,defs
include /usr/share/dpkg/default.mk

libdir = /usr/lib/$(DEB_HOST_MULTIARCH)
libpkg = libserf-1-1

parallel =
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    parallel = -j $(NUMJOBS)
endif

silent =
ifneq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
    silent = --silent
endif

%:
	dh $@

.PHONY: build
build: build-arch build-indep
override_dh_auto_build:
	scons $(parallel) $(silent) GSSAPI=/usr CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" LINKFLAGS="$(LDFLAGS)" PREFIX=/usr LIBDIR=$(libdir)

ifeq (, $(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	if ! [ -d debian/distcerts ]; then \
	    mkdir -p debian/testcerts/private debian/distcerts; \
	    cp test/server/*.pem test/server/serfclientcert.p12 debian/distcerts/; \
	    (cd debian/testcerts && python3 ../create_certs.py); \
	    cp debian/testcerts/*.pem debian/testcerts/private/serfserverkey.pem debian/testcerts/serfclientcert.p12 test/server/; \
	fi
	# Ignore failures until upstream fixes their tests with OpenSSL 3
	scons $(silent) check CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" LINKFLAGS="$(LDFLAGS)" || true
endif

override_dh_auto_clean:
	rm -rf debian/testcerts
	if [ -d debian/distcerts ]; then \
	    rm test/server/*.pem test/server/*.p12; \
	    cp debian/distcerts/* test/server/; \
	fi
	scons -c

override_dh_auto_install:
	scons $(silent) install PREFIX=$(CURDIR)/debian/tmp/usr LIBDIR=debian/tmp$(libdir)
	chrpath -d $(CURDIR)/debian/tmp/$(libdir)/*.so.*

override_dh_installchangelogs:
	dh_installchangelogs CHANGES

override_dh_shlibdeps:
	dh_shlibdeps
	sed -i 's:libserf-private\(, *\)\?::' debian/*.substvars

=== debian/tests/control ===
Tests: upstream-tests
Restrictions: allow-stderr
Depends: @, @builddeps@, pkg-config

## serf 1.3.9.3

=== debian/changelog ===
serf (1.3.9.3-1+rebuild) unstable; urgency=low

  * ['Autobuild release-candidate: 1839893e105bd0ce5af09fee7c9e581207ef73e8']

 -- shuttle <shuttle@deepin.com>  Wed, 11 Dec 2019 20:28:17 +0000

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DEB_BUILD_MAINT_OPTIONS=hardening=+all
DEB_LDFLAGS_MAINT_APPEND=-Wl,-z,defs -Wl,--as-needed
include /usr/share/dpkg/default.mk

libdir = /usr/lib/$(DEB_HOST_MULTIARCH)
libpkg = libserf-1-1

parallel =
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    parallel = -j $(NUMJOBS)
endif

%:
	dh $@

override_dh_auto_build-arch:
	scons $(parallel) GSSAPI=/usr CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" LINKFLAGS="$(LDFLAGS)" PREFIX=/usr LIBDIR=$(libdir)

ifeq (, $(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test-arch:
	if ! [ -d debian/distcerts ]; then \
	    mkdir -p debian/testcerts/private debian/distcerts; \
	    cp test/server/*.pem test/server/serfclientcert.p12 debian/distcerts/; \
	    (cd debian/testcerts && ../create_certs.py); \
	    cp debian/testcerts/*.pem debian/testcerts/private/serfserverkey.pem debian/testcerts/serfclientcert.p12 test/server/; \
	fi
	scons check
endif

override_dh_auto_clean:
	rm -rf debian/testcerts
	if [ -d debian/distcerts ]; then \
	    rm test/server/*.pem test/server/*.p12; \
	    cp debian/distcerts/* test/server/; \
	fi
	scons -c

override_dh_auto_install-arch:
	scons install PREFIX=$(CURDIR)/debian/tmp/usr LIBDIR=$(CURDIR)/debian/tmp$(libdir)
	chrpath -d $(CURDIR)/debian/tmp/$(libdir)/*.so.*

override_dh_installdocs-arch:
	dh_installdocs -a NOTICE --link-doc=$(libpkg)

override_dh_installchangelogs-arch:
	dh_installchangelogs -a CHANGES

override_dh_strip-arch:
	dh_strip -a

override_dh_shlibdeps-arch:
	dh_shlibdeps -a
	sed -i 's:libserf-private\(, *\)\?::' debian/*.substvars

## serf 1.3.10

=== SConstruct ===
--- 
+++ 
@@ -127,7 +127,7 @@
     # Note that Scons 1.3 only supports this on Windows and only when
     # constructing Environment(). Later changes to TARGET_ARCH are ignored
     EnumVariable('TARGET_ARCH',
-                 "Platform to build for (x86|x64|win32|x86_64)",
+                 "Platform to build for",
                  'x86',
                  allowed_values=('x86', 'x86_64', 'ia64'),
                  map={'X86'  : 'x86',
@@ -138,11 +138,20 @@
                      }),
 
     EnumVariable('MSVC_VERSION',
-                 "Visual C++ to use for building (E.g. 11.0, 9.0)",
+                 "Visual C++ to use for building",
                  None,
-                 allowed_values=('14.0', '12.0',
-                                 '11.0', '10.0', '9.0', '8.0', '6.0')
-                ),
+                 allowed_values=('14.3', '14.2', '14.1', '14.0', '12.0',
+                                 '11.0', '10.0', '9.0', '8.0', '6.0'),
+                 map={'2005' :  '8.0',
+                      '2008' :  '9.0',
+                      '2010' : '10.0',
+                      '2012' : '11.0',
+                      '2013' : '12.0',
+                      '2015' : '14.0',
+                      '2017' : '14.1',
+                      '2019' : '14.2',
+                      '2022' : '14.3',
+                     }),
 
     # We always documented that we handle an install layout, but in fact we
     # hardcoded source layouts. Allow disabling this behavior.
@@ -166,7 +175,7 @@
 match = re.search('SERF_MAJOR_VERSION ([0-9]+).*'
                   'SERF_MINOR_VERSION ([0-9]+).*'
                   'SERF_PATCH_VERSION ([0-9]+)',
-                  env.File('serf.h').get_contents(),
+                  env.File('serf.h').get_contents().decode('utf-8'),
                   re.DOTALL)
 MAJOR, MINOR, PATCH = [int(x) for x in match.groups()]
 env.Append(MAJOR=str(MAJOR))
@@ -183,7 +192,7 @@
 
 unknown = opts.UnknownVariables()
 if unknown:
-  print 'Warning: Used unknown variables:', ', '.join(unknown.keys())
+  print('Warning: Used unknown variables:', ', '.join(unknown.keys()))
 
 apr = str(env['APR'])
 apu = str(env['APU'])
@@ -268,7 +277,10 @@
     env.Append(PLATFORM='posix')
 else:
   # Warning level 4, no unused argument warnings
-  env.Append(CCFLAGS=['/W4', '/wd4100'])
+  env.Append(CCFLAGS=['/W4',
+                      '/wd4100', # Unused argument
+                      '/we4013', # 'function' undefined; assuming extern returning int
+                     ])
 
   # Choose runtime and optimization
   if debug:
@@ -291,6 +303,9 @@
 
 lib_static = env.StaticLibrary(LIBNAMESTATIC, SOURCES)
 lib_shared = env.SharedLibrary(LIBNAME, SOURCES + SHARED_SOURCES)
+
+# Define OPENSSL_NO_STDIO to prevent using _fp() API.
+env.Append(CPPDEFINES=['OPENSSL_NO_STDIO'])
 
 if aprstatic:
   env.Append(CPPDEFINES=['APR_DECLARE_STATIC', 'APU_DECLARE_STATIC'])
@@ -335,25 +350,8 @@
                LIBPATH=['$ZLIB'])
 
   # openssl
-  env.Append(LIBS=['libeay32.lib', 'ssleay32.lib'])
   if not env.get('SOURCE_LAYOUT', None):
     env.Append(CPPPATH=['$OPENSSL/include/openssl'],
                LIBPATH=['$OPENSSL/lib'])
   elif 0: # opensslstatic:
     env.Append(CPPPATH=['$OPENSSL/inc32'],
-               LIBPATH=['$OPENSSL/out32'])
-  else:
-    env.Append(CPPPATH=['$OPENSSL/inc32'],
-               LIBPATH=['$OPENSSL/out32dll'])
-else:
-  if os.path.isdir(apr):
-    apr = os.path.join(apr, 'bin', 'apr-1-config')
-    env['APR'] = apr
-  if os.path.isdir(apu):
-    apu = os.path.join(apu, 'bin', 'apu-1-config')
-    env['APU'] = apu
-
-  ### we should use --cc, but that is giving some scons error about an implict
-  ### dependency upon gcc. probably ParseConfig doesn't know what to do with
-  ### the apr-1-config output
-  if CALLOUT_OKAY:

=== debian/changelog ===
serf (1.3.10-3) unstable; urgency=medium

  * Allow overriding the compiler used to build serf
  * Fix FTBFS with gcc-14 (Closes: #1075504)
  * Declare compliance with Policy 4.7.0, no changes needed

 -- James McCoy <jamessan@debian.org>  Thu, 04 Jul 2024 16:32:56 -0400

serf (1.3.10-2) unstable; urgency=medium

  * Remove automatic re-building of upstream test certs.  The test certs have
    a long enough expiration (100 years) to avoid random FTBFS and the cert
    update script was broken by the removal of APIs from python3-openssl.

 -- James McCoy <jamessan@debian.org>  Mon, 25 Mar 2024 22:05:04 -0400

serf (1.3.10-1) unstable; urgency=medium

  * New upstream release
    - Remove patches applied upstream: openssl-1.1.1i, openssl-3.x,
      bio-ctrl.patch, and py3-compat
  * Adjust symbols-declares-dependency-on-other-package override for new lintian
  * Bump to debhelper compat 13
  * Stop ignoring test results now that they work with OpenSSL 3
  * Point fetch-keys script at new KEYS URL
  * Update upstream signing keys
  * Declare compliance with Policy 4.6.2, no changes needed

 -- James McCoy <jamessan@debian.org>  Sun, 11 Jun 2023 13:43:46 -0400

=== debian/control ===
--- 
+++ 
@@ -4,15 +4,14 @@
 Maintainer: James McCoy <jamessan@debian.org>
 Build-Depends:
  chrpath,
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  libapr1-dev,
  libaprutil1-dev,
  libkrb5-dev,
  libssl-dev,
- python3-openssl <!nocheck>,
  scons,
  zlib1g-dev,
-Standards-Version: 4.6.1
+Standards-Version: 4.7.0
 Homepage: https://serf.apache.org/
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/jamessan/serf.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DEB_BUILD_MAINT_OPTIONS=hardening=+all
DEB_LDFLAGS_MAINT_APPEND=-Wl,-z,defs
include /usr/share/dpkg/default.mk

libdir = /usr/lib/$(DEB_HOST_MULTIARCH)
libpkg = libserf-1-1

parallel =
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    parallel = -j $(NUMJOBS)
endif

silent =
ifneq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
    silent = --silent
endif

%:
	dh $@

.PHONY: build
build: build-arch build-indep
override_dh_auto_build:
	scons $(parallel) $(silent) GSSAPI=/usr CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" LINKFLAGS="$(LDFLAGS)" PREFIX=/usr LIBDIR=$(libdir) CC="$(CC)"

override_dh_auto_test:
	scons $(silent) check CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" LINKFLAGS="$(LDFLAGS)" CC="$(CC)"

override_dh_auto_clean:
	scons -c

override_dh_auto_install:
	scons $(silent) install PREFIX=$(CURDIR)/debian/tmp/usr LIBDIR=debian/tmp$(libdir)
	chrpath -d $(CURDIR)/debian/tmp/$(libdir)/*.so.*

override_dh_installchangelogs:
	dh_installchangelogs CHANGES

override_dh_shlibdeps:
	dh_shlibdeps
	sed -i 's:libserf-private\(, *\)\?::' debian/*.substvars
